﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.98
@EndOfDesignText@
#Event: NewMessage (s As String)
Sub Class_Globals
	Private mCallback As Object
	Private mEventName As String
	Private const PackageName As String = "b4j.example" '<------ change as needed
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
'   #if RELEASE
	mCallback = Callback
	mEventName = EventName
	Dim out As JavaObject
	out.InitializeNewInstance($"${PackageName}.logger$MyOutputStream"$, Array(Me))
	Dim ps As JavaObject
	ps.InitializeNewInstance("java.io.PrintStream", Array(out, True, "utf8"))
	Dim jo As JavaObject
	jo.InitializeStatic("java.lang.System")
	jo.RunMethod("setOut", Array(ps))
	jo.RunMethod("setErr", Array(ps))
'   #end if
End Sub


Private Sub Data_Available (Buffer() As Byte)
	CallSub2(mCallback, mEventName & "_NewMessage", BytesToString(Buffer, 0, Buffer.Length, "utf8"))
End Sub


#if Java
import java.io.*;
public static class MyOutputStream extends OutputStream {
	B4AClass cls;
	private boolean closed;
	public MyOutputStream (B4AClass cls) {
		this.cls = cls;
	}
	
	public void write(int b) throws IOException {
		if (closed)
			throw new IOException("closed");
		cls.getBA().raiseEventFromDifferentThread (null, null, 0, "data_available", true, new Object[] {new byte[] {(byte)b}});
	}
	public void write(byte b[], int off, int len) throws IOException {
		if (closed)
			throw new IOException("closed");
		byte[] bb = new byte[len];
		System.arraycopy(b, off, bb, 0, len);
		cls.getBA().raiseEventFromDifferentThread (null, null, 0, "data_available", true, new Object[] {bb});
	}
	public void close() {
		closed = true;
	}
}
#End If

